function output = makeFbaTable(irrModel, dataStruct)
	filename = dataStruct.filename;
	inputPtclIndexes = dataStruct.inputPtclIndexes;
	outputPtclIndexes = dataStruct.outputPtclIndexes;
	maxUpperBounds = dataStruct.maxUpperBounds;
	inputStride = dataStruct.inputStride;
	
	inputBackwardFluxIndexes = dataStruct.inputBackwardFluxIndexes;

	outputForwardFluxIndexes = dataStruct.outputForwardFluxIndexes;
	outputBackwardFluxIndexes = dataStruct.outputBackwardFluxIndexes;
	
	grIndex = dataStruct.grIndex;
	
	numberTabledValues = maxUpperBounds ./ inputStride + 1;
	
	fileID_all = fopen(filename, 'w');
	fprintf(fileID_all, 'nInputs:\t%i\n', length(inputPtclIndexes));
	fprintf(fileID_all, 'nOutputs:\t%i\n', length(outputPtclIndexes) + 1);
	
	fprintf(fileID_all, 'inputIndexes:\t');
	fprintf(fileID_all, '%i\t', inputPtclIndexes(1:(length(inputPtclIndexes) - 1)));
	fprintf(fileID_all, '%i\n', inputPtclIndexes(end));
	
	fprintf(fileID_all, 'outputIndexes:\t');
	fprintf(fileID_all, '%i\t', outputPtclIndexes(1:(length(outputPtclIndexes) - 1)));
	fprintf(fileID_all, '%i\n', outputPtclIndexes(end));
	
	fprintf(fileID_all, 'numberOfTabledValues:\t');
	fprintf(fileID_all, '%i\t', numberTabledValues(1:(length(numberTabledValues) - 1)));
	fprintf(fileID_all, '%i\n', numberTabledValues(end));
	
	fprintf(fileID_all, 'inputStride:\t');
	fprintf(fileID_all, '%i\t', inputStride(1:(length(inputStride) - 1)));
	fprintf(fileID_all, '%i\n', inputStride(end));
	
	fprintf(fileID_all, 'fbaTable:\n');
	
	maxI = length(inputPtclIndexes);
    %minimizedFlux, minimizedFluxPre, modelIrrev, modelIrrevPre
	[soln, ~, basicModel, ~] = pfbaJAC(irrModel, 0);
	
	zeds = zeros(1, length(outputPtclIndexes) + 1);
	
	for i1 = 0.0:inputStride(1):maxUpperBounds(1)
		if maxI == 1
			realModel = basicModel;
			realModel.ub(inputBackwardFluxIndexes) = i1;
			thisSoln = pfbaJAC(realModel, 0);
			if thisSoln.f == 0.0
				fprintf(fileID_all, '%4.6f\t', zeds(2:end));
				fprintf(fileID_all, '%4.6f\n', zeds(end));
			else
				fprintf(fileID_all, '%4.6f\t', (thisSoln.x(outputForwardFluxIndexes) - thisSoln.x(outputBackwardFluxIndexes)));
				fprintf(fileID_all, '%4.6f\n', thisSoln.x(grIndex));
			end
		else
			for i2 = 0.0:inputStride(2):maxUpperBounds(2)
				if maxI == 2
					realModel = basicModel;
					realModel.ub(inputBackwardFluxIndexes) = [i1 i2];
					thisSoln = pfbaJAC(realModel, 0);
					if thisSoln.f == 0.0
						fprintf(fileID_all, '%4.6f\t', zeds(2:end));
						fprintf(fileID_all, '%4.6f\n', zeds(end));
					else
						fprintf(fileID_all, '%4.6f\t', (thisSoln.x(outputForwardFluxIndexes) - thisSoln.x(outputBackwardFluxIndexes)));
						fprintf(fileID_all, '%4.6f\n', thisSoln.x(grIndex));
					end
				else
					for i3 = 0.0:inputStride(3):maxUpperBounds(3)
						if maxI == 3
							realModel = basicModel;
							realModel.ub(inputBackwardFluxIndexes) = [i1 i2 i3];
							thisSoln = pfbaJAC(realModel, 0);
							if thisSoln.f == 0.0
								fprintf(fileID_all, '%4.6f\t', zeds(2:end));
								fprintf(fileID_all, '%4.6f\n', zeds(end));
							else
								fprintf(fileID_all, '%4.6f\t', (thisSoln.x(outputForwardFluxIndexes) - thisSoln.x(outputBackwardFluxIndexes)));
								fprintf(fileID_all, '%4.6f\n', thisSoln.x(grIndex));
							end
						else
							for i4 = 0.0:inputStride(4):maxUpperBounds(4)
								if maxI == 4
									realModel = basicModel;
									realModel.ub(inputBackwardFluxIndexes) = [i1 i2 i3 i4];
									thisSoln = pfbaJAC(realModel, 0);
									if thisSoln.f == 0.0
										fprintf(fileID_all, '%4.6f\t', zeds(2:end));
										fprintf(fileID_all, '%4.6f\n', zeds(end));
									else
										fprintf(fileID_all, '%4.6f\t', (thisSoln.x(outputForwardFluxIndexes) - thisSoln.x(outputBackwardFluxIndexes)));
										fprintf(fileID_all, '%4.6f\n', thisSoln.x(grIndex));
									end
								else
									for i5 = 0.0:inputStride(5):maxUpperBounds(5)
										if maxI == 5
											realModel = basicModel;
											realModel.ub(inputBackwardFluxIndexes) = [i1 i2 i3 i4 i5];
											thisSoln = pfbaJAC(realModel, 0);
											if thisSoln.f == 0.0
												fprintf(fileID_all, '%4.6f\t', zeds(2:end));
												fprintf(fileID_all, '%4.6f\n', zeds(end));
											else
												fprintf(fileID_all, '%4.6f\t', (thisSoln.x(outputForwardFluxIndexes) - thisSoln.x(outputBackwardFluxIndexes)));
												fprintf(fileID_all, '%4.6f\n', thisSoln.x(grIndex));
											end
										else
											for i6 = 0.0:inputStride(6):maxUpperBounds(6)
												if maxI == 6
													realModel = basicModel;
													realModel.ub(inputBackwardFluxIndexes) = [i1 i2 i3 i4 i5 i6];
													thisSoln = pfbaJAC(realModel, 0);
													if thisSoln.f == 0.0
														fprintf(fileID_all, '%4.6f\t', zeds(2:end));
														fprintf(fileID_all, '%4.6f\n', zeds(end));
													else
														fprintf(fileID_all, '%4.6f\t', (thisSoln.x(outputForwardFluxIndexes) - thisSoln.x(outputBackwardFluxIndexes)));
														fprintf(fileID_all, '%4.6f\n', thisSoln.x(grIndex));
													end
												else
													for i7 = 0.0:inputStride(7):maxUpperBounds(7)
														if maxI == 7
															realModel = basicModel;
															realModel.ub(inputBackwardFluxIndexes) = [i1 i2 i3 i4 i5 i6 i7];
															thisSoln = pfbaJAC(realModel, 0);
															if thisSoln.f == 0.0
																fprintf(fileID_all, '%4.6f\t', zeds(2:end));
																fprintf(fileID_all, '%4.6f\n', zeds(end));
															else
																fprintf(fileID_all, '%4.6f\t', (thisSoln.x(outputForwardFluxIndexes) - thisSoln.x(outputBackwardFluxIndexes)));
																fprintf(fileID_all, '%4.6f\n', thisSoln.x(grIndex));
															end
														else
															for i8 = 0.0:inputStride(8):maxUpperBounds(8)
																if maxI == 8
																	realModel = basicModel;
																	realModel.ub(inputBackwardFluxIndexes) = [i1 i2 i3 i4 i5 i6 i7 i8];
																	thisSoln = pfbaJAC(realModel, 0);
																	if thisSoln.f == 0.0
																		fprintf(fileID_all, '%4.6f\t', zeds(2:end));
																		fprintf(fileID_all, '%4.6f\n', zeds(end));
																	else
																		fprintf(fileID_all, '%4.6f\t', (thisSoln.x(outputForwardFluxIndexes) - thisSoln.x(outputBackwardFluxIndexes)));
																		fprintf(fileID_all, '%4.6f\n', thisSoln.x(grIndex));
																	end
																else
																	for i9 = 0.0:inputStride(9):maxUpperBounds(9)
																		if maxI == 9
																			realModel = basicModel;
																			realModel.ub(inputBackwardFluxIndexes) = [i1 i2 i3 i4 i5 i6 i7 i8 i9];
																			thisSoln = pfbaJAC(realModel, 0);
																			if thisSoln.f == 0.0
																				fprintf(fileID_all, '%4.6f\t', zeds(2:end));
																				fprintf(fileID_all, '%4.6f\n', zeds(end));
																			else
																				fprintf(fileID_all, '%4.6f\t', (thisSoln.x(outputForwardFluxIndexes) - thisSoln.x(outputBackwardFluxIndexes)));
																				fprintf(fileID_all, '%4.6f\n', thisSoln.x(grIndex));
																			end
																		else
																			for i10 = 0.0:inputStride(10):maxUpperBounds(10)
																				if maxI == 10
																					realModel = basicModel;
																					realModel.ub(inputBackwardFluxIndexes) = [i1 i2 i3 i4 i5 i6 i7 i8 i9 i10];
																					thisSoln = pfbaJAC(realModel, 0);
																					if thisSoln.f == 0.0
																						fprintf(fileID_all, '%4.6f\t', zeds(2:end));
																						fprintf(fileID_all, '%4.6f\n', zeds(end));
																					else
																						fprintf(fileID_all, '%4.6f\t', (thisSoln.x(outputForwardFluxIndexes) - thisSoln.x(outputBackwardFluxIndexes)));
																						fprintf(fileID_all, '%4.6f\n', thisSoln.x(grIndex));
																					end
																				end
																			end
																		end
																	end
																end
															end
														end
													end
												end
											end
										end
									end
								end
							end
						end
					end
				end
			end
		end
	end
	fclose(fileID_all);
	out = 'done';
	return;
end


function [minimizedFlux, minimizedFluxPre, modelIrrev, modelIrrevPre] = pfbaJAC(model,GeneOption)
% This function finds the minimum flux through the network and returns the
% minimized flux and an irreversible model

% convert model to irrev
if model.reversibleModel > 0
    modelIrrev = convertToIrreversible(model);
else
    modelIrrev = model;
end
soln1 = optimizeCbModel(modelIrrev);
gr = soln1.f;
bmRxn = find(modelIrrev.c);
modelIrrev.lb(bmRxn) = gr;
modelIrrev.ub(bmRxn) = gr;

modelIrrevPre = modelIrrev;

%does netFlux exist?
flag = find(ismember(modelIrrev.rxns, 'netFlux'));
if isempty(flag)
    % add pseudo-metabolite to measure flux through network
    if nargin==1,GeneOption=0;
    end
    if GeneOption==0, % signal that you want to minimize the sum of all gene and non-gene associated fluxes
        modelIrrev.S(end+1,:) = ones(size(modelIrrev.S(1,:)));
    elseif GeneOption==1, % signal that you want to minimize the sum of only gene-associated fluxes
        %find all reactions which are gene associated
        Ind=find(sum(modelIrrev.rxnGeneMat,2)>0);
        modelIrrev.S(end+1,:) = zeros(size(modelIrrev.S(1,:)));
        modelIrrev.S(end,Ind) = 1;
    end
    modelIrrev.b(end+1) = 0;
    modelIrrev.mets{end+1} = 'fluxMeasure';

    % add a pseudo reaction that measures the flux through the network
    modelIrrev = addReaction(modelIrrev,'netFlux',{'fluxMeasure'},[-1],false,0,inf,0,'','');
end

% set the flux measuring demand as the objective
modelIrrev.c = zeros(length(modelIrrev.rxns),1);
modelIrrev = changeObjective(modelIrrev, 'netFlux');

% minimize the flux measuring demand (netFlux)
minimizedFlux = optimizeCbModel(modelIrrev,'min');
minimizedFluxPre = minimizedFlux.x(1:(length(minimizedFlux.x)-1));

%put the objective back to biomass
modelIrrev.c = zeros(length(modelIrrev.rxns),1);
modelIrrev.c(bmRxn) = 1;
modelIrrev.lb(bmRxn) = 0.0;
modelIrrev.ub(bmRxn) = 1000.0;
end